
## One solution to Locker Room Problem



























from threading_cleanup import *
import random

class LockerRoom:
    def __init__(self):
        #don't use occupants in your solution
        self.occupants = []
        self.males = 0
        self.females = 0
        self.mutex = Semaphore(1)
        self.femaleMutex = Semaphore(1)
        self.maleMutex = Semaphore(1)
        self.roomEmpty = Semaphore(1)

    def enter(self, gender):
        self.mutex.wait()
        self.occupants.append(gender)
        print self.occupants
        self.mutex.signal()

    def leave(self, gender):
        self.mutex.wait()
        self.occupants.remove(gender)
        print self.occupants
        self.mutex.signal()

def male(lockerRoom):
    lockerRoom.maleMutex.wait()
    lockerRoom.males += 1
    if lockerRoom.males == 1:
        lockerRoom.roomEmpty.wait()
    lockerRoom.maleMutex.signal()
    # Critical section
    lockerRoom.enter('male')
    time.sleep(random.random() / 2)
    lockerRoom.leave('male')
    # end of critical section

    lockerRoom.maleMutex.wait()
    lockerRoom.males -= 1
    if lockerRoom.males == 0:
        lockerRoom.roomEmpty.signal()
    lockerRoom.maleMutex.signal()

def female(lockerRoom):
    lockerRoom.femaleMutex.wait()
    lockerRoom.females += 1
    if lockerRoom.females == 1:
        lockerRoom.roomEmpty.wait()
    lockerRoom.femaleMutex.signal()
    # Critical section
    lockerRoom.enter('female')
    time.sleep(random.random() / 2)
    lockerRoom.leave('female')
    # end of critical section

    lockerRoom.femaleMutex.wait()
    lockerRoom.females -= 1
    if lockerRoom.females == 0:
        lockerRoom.roomEmpty.signal()
    lockerRoom.femaleMutex.signal()
    

def loop(lockerRoom, f, mu=1):
    while True:
        t = random.expovariate(1.0/mu)
        time.sleep(t)
        f(lockerRoom)

lockerRoom = LockerRoom()
fs = [male]*5 + [female]*5 
threads = [Thread(loop, lockerRoom, f) for f in fs]
for thread in threads: thread.join()

